scala.tools.nsc.Global

# mixer

#### object mixer extends Mixin

Source
  Global.scala

Linear Supertypes
Mixin, TreeDSL, InfoTransform, Transform, SubComponent, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. mixer
2. Mixin
3. TreeDSL
4. InfoTransform
5. Transform
6. SubComponent
7. AnyRef
8. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class MixinTransformer extends Global.Transformer

   Definition Classes
     Mixin

2. #### class Phase extends InfoTransform.Phase

   Definition Classes
     InfoTransform

3. #### abstract class StdPhase extends GlobalPhase

   A standard phase template

   A standard phase template

   Definition Classes
     SubComponent

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### object CODE

   Definition Classes
     TreeDSL

5. #### def addLateInterfaceMembers(clazz: Global.Symbol): Unit

   Add getters and setters for all non-module fields of an implementation class to its interface unless they are already present.

   Add getters and setters for all non-module fields of an implementation class to its interface unless they are already present. This is done only once per class. The mixedin flag is used to remember whether late members have been added to an interface.

   - lazy fields don't get a setter.
   Definition Classes
     Mixin

6. #### def addMember(clazz: Global.Symbol, member: Global.Symbol): Global.Symbol

   Add given member to given class, and mark member as mixed-in.

   Add given member to given class, and mark member as mixed-in.

   Definition Classes
     Mixin

7. #### def addMixedinMembers(clazz: Global.Symbol, unit: Global.CompilationUnit): Unit

   Add all members to be mixed in into a (non-trait-) class These are: for every mixin trait T that is not also inherited by the superclass: add late interface members to T and then:

   Add all members to be mixed in into a (non-trait-) class These are: for every mixin trait T that is not also inherited by the superclass: add late interface members to T and then:

   - if a member M of T is forwarded to the implementation class, add a forwarder for M unless one exists already. The alias of the forwarder is the static member it forwards to.
   - for every abstract accessor in T, add a field and an implementation for that accessor
   - for every super accessor in T, add an implementation of that accessor
   - for every module in T, add a module
   Definition Classes
     Mixin

8. #### final def afterOwnPhase[T](op: ⇒ T): T

   Definition Classes
     SubComponent
   Annotations
     @inline()

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

11. #### def changesBaseClasses: Boolean

    Attributes
      protected
    Definition Classes
      InfoTransform

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### def cloneAndAddMember(mixinClass: Global.Symbol, mixinMember: Global.Symbol, clazz: Global.Symbol): Global.Symbol

    Definition Classes
      Mixin

14. #### def cloneBeforeErasure(mixinClass: Global.Symbol, mixinMember: Global.Symbol, clazz: Global.Symbol): Global.Symbol

    Definition Classes
      Mixin

15. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

16. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### val global: Global.this.type

    The global environment; overridden by instantiation in Global.

    The global environment; overridden by instantiation in Global.

    Definition Classes
      mixer → TreeDSL → SubComponent

21. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    Definition Classes
      SubComponent → AnyRef → Any

22. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

23. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

24. #### def isConcreteAccessor(member: Global.Symbol): Boolean

    Definition Classes
      Mixin

25. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

26. #### def isOverriddenAccessor(member: Global.Symbol, bcs: List[Global.Symbol]): Boolean

    Is member overridden (either directly or via a bridge) in base class sequence `bcs`?

    Is member overridden (either directly or via a bridge) in base class sequence `bcs`?

    Definition Classes
      Mixin

27. #### def keepsTypeParams: Boolean

    Attributes
      protected
    Definition Classes
      InfoTransform

28. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

29. #### def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      InfoTransform → Transform → SubComponent

30. #### def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Attributes
      protected
    Definition Classes
      Mixin → Transform

31. #### final def notify(): Unit

    Definition Classes
      AnyRef

32. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

33. #### def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

34. #### val phaseName: String

    The name of the phase:

    The name of the phase:

    Definition Classes
      Mixin → SubComponent

35. #### def phaseNewFlags: Long

    The phase might set the following new flags:

    The phase might set the following new flags:

    Definition Classes
      Mixin → SubComponent

36. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

37. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

38. #### val runsAfter: collection.immutable.List[String]

    Names of phases that must run before this phase.

    Names of phases that must run before this phase.

    Definition Classes
      mixer → SubComponent

39. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

40. #### val runsRightAfter: None.type

    Name of the phase that this phase must follow immediately.

    Name of the phase that this phase must follow immediately.

    Definition Classes
      mixer → SubComponent

41. #### def singleUseFields(templ: Global.Template): Map[Global.Symbol, List[Global.Symbol]]

    Return a map of single-use fields to the lazy value that uses them during initialization.

    Return a map of single-use fields to the lazy value that uses them during initialization. Each field has to be private and defined in the enclosing class, and there must be exactly one lazy value using it.

    Such fields will be nulled after the initializer has memoized the lazy value.

    Definition Classes
      Mixin

42. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

43. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

44. #### def toString(): String

    Definition Classes
      AnyRef → Any

45. #### def transformInfo(sym: Global.Symbol, tp: Global.Type): Global.Type

    The info transform for this phase does the following:

    The info transform for this phase does the following:

    - The parents of every class are mapped from implementation class to interface
    - Implementation classes become modules that inherit nothing and that define all.
    Definition Classes
      Mixin → InfoTransform

46. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from Mixin

### Inherited from TreeDSL

### Inherited from InfoTransform

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Ungrouped